function [Beta2,W2,b2,c2]=MatDBNY_Hierarchical_Topics0_101iid_GPU(Data0, VIndices0, NHidden, aparm, bparm, cparm, MiniBatchLen, NContrastiveDivergence,num_iterations,tau0,kappa,l2reg,num_of_hist_boxes)
    function tmp=sigma_function(x)
        tmp = 1.0./(1.0+exp(-x));
    end

    function [EHFP]=propagate_data2(EHFP,W,b,k)
        tmp=W{k-1,1,1}.'*EHFP.'+b{k-1,1,1}(:)*ones(1,size(EHFP,1));%./repmat(num_words_hist.',[NHidden,1]); 
        EHFP=1./(1+exp(-tmp));
    end

    function [EHFP]=propagate_data(MiniBatchData,W,b)
        VFP0=MiniBatchData;
        num_words_hist=sum(VFP0,2);
        tmp=(W.'*VFP0.'+b(:)*num_words_hist.');%./repmat(num_words_hist.',[NHidden,1]);
        EHFP=1./(1+exp(-tmp));
    end
    function [Pbar]=SampleP2(MiniBatchData,W,P,b,NHidden,MiniBatchLen)

        
        Pbar.a=[];
        Pbar.b=[];
            
        O1=parallel.gpu.GPUArray.ones(NHidden,MiniBatchLen,'single');
        tmp=W.'*MiniBatchData.'+repmat(b,1,MiniBatchLen);
        PH1=log(P+eps)+tmp;
        PH2=log(P+eps);
        PH3=log(1.0-P+eps);
        PH4=log(1.0-P+eps);
        tmp_PH=parallel.gpu.GPUArray.zeros(NHidden*MiniBatchLen,4,'single');
        tmp_PH(:,1)=reshape(PH1,NHidden*MiniBatchLen,1);
        tmp_PH(:,2)=reshape(PH2,NHidden*MiniBatchLen,1);
        tmp_PH(:,3)=reshape(PH3,NHidden*MiniBatchLen,1);
        tmp_PH(:,4)=reshape(PH4,NHidden*MiniBatchLen,1);
        maxPH=reshape(max(tmp_PH,[],2),NHidden,MiniBatchLen);
        PH1=exp(PH1-maxPH);
        PH2=exp(PH2-maxPH);
        PH3=exp(PH3-maxPH);
        PH4=exp(PH4-maxPH);
        PHsum=PH1+PH2+PH3+PH4;
            
        rnd_mat=parallel.gpu.GPUArray.rand(NHidden,MiniBatchLen,'single').*PHsum;
        ind1=rnd_mat<=PH1;
        ind2=(rnd_mat>PH1).*(rnd_mat<=(PH1+PH2));
        ind3=(rnd_mat>(PH1+PH2)).*(rnd_mat<=(PH1+PH2+PH3));
        ind4=(rnd_mat>(PH1+PH2+PH3));

        Pbar.a=O1.*(ind1+ind2);
    end

    function [HFP,VFP,Pbar,VFPP,EHFP]=ContrastiveDivergence2(MiniBatchData,W,P,b,c,NContrastiveDivergence,NHidden,MiniBatchLen,NVisible)

        VFP.a=[];
        VFP.b=[];
        Pbar.a=[];
        Pbar.b=[];
        HFP.a=[];
        HFP.b=[];
        EHFP.a=[];
        EHFP.b=[];
        VFPP.a=[];
        VFPP.b=[];
            
        O1=parallel.gpu.GPUArray.ones(NHidden,MiniBatchLen,'single');
        O2=parallel.gpu.GPUArray.ones(NVisible,MiniBatchLen,'single');
        VFP.a=MiniBatchData;
        tmp=W.'*VFP.a.'+repmat(b,1,MiniBatchLen);
        PH1=log(P+eps)+tmp;
        PH2=log(P+eps);
        PH3=log(1.0-P+eps);
        PH4=log(1.0-P+eps);
        tmp_PH=parallel.gpu.GPUArray.zeros(NHidden*MiniBatchLen,4,'single');
        tmp_PH(:,1)=reshape(PH1,NHidden*MiniBatchLen,1);
        tmp_PH(:,2)=reshape(PH2,NHidden*MiniBatchLen,1);
        tmp_PH(:,3)=reshape(PH3,NHidden*MiniBatchLen,1);
        tmp_PH(:,4)=reshape(PH4,NHidden*MiniBatchLen,1);
        maxPH=reshape(max(tmp_PH,[],2),NHidden,MiniBatchLen);
        PH1=exp(PH1-maxPH);
        PH2=exp(PH2-maxPH);
        PH3=exp(PH3-maxPH);
        PH4=exp(PH4-maxPH);
        PHsum=PH1+PH2+PH3+PH4;
            
        rnd_mat=parallel.gpu.GPUArray.rand(NHidden,MiniBatchLen,'single').*PHsum;
        ind1=rnd_mat<=PH1;
        ind2=(rnd_mat>PH1).*(rnd_mat<=(PH1+PH2));
        ind3=(rnd_mat>(PH1+PH2)).*(rnd_mat<=(PH1+PH2+PH3));
        ind4=(rnd_mat>(PH1+PH2+PH3));

        Pbar.a=O1.*(ind1+ind2);
        HFP.a=O1.*(ind1+ind4);
        EHFP.a=PH1./(PHsum);
   
        VFPP.b=sigma_function(W*(HFP.a.*Pbar.a)+repmat(c,1,MiniBatchLen)).';
        flg=parallel.gpu.GPUArray.rand(MiniBatchLen,NVisible,'single')<VFPP.b;
        VFP.b=O2.'.*flg;
        %%%%%%%%%%%%%%%%%%%%%
        i0=1;
        while 1
            tmp=W.'*VFP.b.'+repmat(b,1,MiniBatchLen);
            PH1=log(P+eps)+tmp;
            PH2=log(P+eps);
            PH3=log(1.0-P+eps);
            PH4=log(1.0-P+eps);
            
            tmp_PH=parallel.gpu.GPUArray.zeros(NHidden*MiniBatchLen,4,'single');
            tmp_PH(:,1)=reshape(PH1,NHidden*MiniBatchLen,1);
            tmp_PH(:,2)=reshape(PH2,NHidden*MiniBatchLen,1);
            tmp_PH(:,3)=reshape(PH3,NHidden*MiniBatchLen,1);
            tmp_PH(:,4)=reshape(PH4,NHidden*MiniBatchLen,1);
            maxPH=reshape(max(tmp_PH,[],2),NHidden,MiniBatchLen);

            PH1=exp(PH1-maxPH);
            PH2=exp(PH2-maxPH);
            PH3=exp(PH3-maxPH);
            PH4=exp(PH4-maxPH);
            PHsum=PH1+PH2+PH3+PH4;
            
            rnd_mat=parallel.gpu.GPUArray.rand(NHidden,MiniBatchLen,'single').*PHsum;
            ind1=rnd_mat<=PH1;
            ind2=(rnd_mat>PH1).*(rnd_mat<=(PH1+PH2));
            ind3=(rnd_mat>(PH1+PH2)).*(rnd_mat<=(PH1+PH2+PH3));
            ind4=(rnd_mat>(PH1+PH2+PH3));

            Pbar.b=O1.*(ind1+ind2);
            HFP.b=O1.*(ind1+ind4);
            EHFP.b=PH1./(PHsum);

            if i0<NContrastiveDivergence
                i0=i0+1;
                VFPP.b=sigma_function(W*(HFP.b.*Pbar.b)+repmat(c,1,MiniBatchLen)).';
                flg=parallel.gpu.GPUArray.rand(MiniBatchLen,NVisible,'single')<VFPP.b;
                VFP.b=O2.'.*flg;
            else
                break;
            end
        end             
    end


    function [Pbar]=SampleP(MiniBatchData,W,P,b,NHidden,MiniBatchLen)
        Pbar.a=[];
        Pbar.b=[];

        num_words_hist=sum(MiniBatchData,2);
        O1=parallel.gpu.GPUArray.ones(NHidden,MiniBatchLen,'single');
%         size(U(:,MiniBatchIndices))
%         size(repmat(num_words_hist.',[NHidden,1]))
        tmp=(W.'*MiniBatchData.'+b(:)*num_words_hist.');%./repmat(num_words_hist.',[NHidden,1]);
        PH1=log(P+eps)+tmp;
        PH2=log(P+eps);
        PH3=log(1.0-P+eps);
        PH4=log(1.0-P+eps);
        tmp_PH=parallel.gpu.GPUArray.zeros(NHidden*MiniBatchLen,4,'single');
        tmp_PH(:,1)=reshape(PH1,NHidden*MiniBatchLen,1);
        tmp_PH(:,2)=reshape(PH2,NHidden*MiniBatchLen,1);
        tmp_PH(:,3)=reshape(PH3,NHidden*MiniBatchLen,1);
        tmp_PH(:,4)=reshape(PH4,NHidden*MiniBatchLen,1);
        maxPH=reshape(max(tmp_PH,[],2),NHidden,MiniBatchLen);
        PH1=exp(PH1-maxPH);
        PH2=exp(PH2-maxPH);
        PH3=exp(PH3-maxPH);
        PH4=exp(PH4-maxPH);
        PHsum=PH1+PH2+PH3+PH4;
            
        rnd_mat=parallel.gpu.GPUArray.rand(NHidden,MiniBatchLen,'single').*PHsum;
        ind1=rnd_mat<=PH1;
        ind2=(rnd_mat>PH1).*(rnd_mat<=(PH1+PH2));
        ind3=(rnd_mat>(PH1+PH2)).*(rnd_mat<=(PH1+PH2+PH3));
        ind4=(rnd_mat>(PH1+PH2+PH3));

        Pbar.a=O1.*(ind1+ind2);
    end

    function [HFP,VFP,Pbar,VFPP,EHFP]=ContrastiveDivergence(MiniBatchData,W,P,b,c,NContrastiveDivergence,NHidden,MiniBatchLen,NVisible)

        VFP.a=[];
        VFP.b=[];

        Pbar.a=[];
        Pbar.b=[];
        HFP.a=[];
        HFP.b=[];
        EHFP.a=[];
        EHFP.b=[];
        VFPP.a=[];
        VFPP.b=[];
            
        VFP.a=MiniBatchData;
        num_words_hist=sum(VFP.a,2);
        O1=parallel.gpu.GPUArray.ones(NHidden,MiniBatchLen,'single');
%         size(U(:,MiniBatchIndices))
%         size(repmat(num_words_hist.',[NHidden,1]))
        tmp=(W.'*VFP.a.'+b(:)*num_words_hist.');%./repmat(num_words_hist.',[NHidden,1]);
        PH1=log(P+eps)+tmp;
        PH2=log(P+eps);
        PH3=log(1.0-P+eps);
        PH4=log(1.0-P+eps);
        tmp_PH=parallel.gpu.GPUArray.zeros(NHidden*MiniBatchLen,4,'single');
        tmp_PH(:,1)=reshape(PH1,NHidden*MiniBatchLen,1);
        tmp_PH(:,2)=reshape(PH2,NHidden*MiniBatchLen,1);
        tmp_PH(:,3)=reshape(PH3,NHidden*MiniBatchLen,1);
        tmp_PH(:,4)=reshape(PH4,NHidden*MiniBatchLen,1);
        maxPH=reshape(max(tmp_PH,[],2),NHidden,MiniBatchLen);
        PH1=exp(PH1-maxPH);
        PH2=exp(PH2-maxPH);
        PH3=exp(PH3-maxPH);
        PH4=exp(PH4-maxPH);
        PHsum=PH1+PH2+PH3+PH4;
            
        rnd_mat=parallel.gpu.GPUArray.rand(NHidden,MiniBatchLen,'single').*PHsum;
        ind1=rnd_mat<=PH1;
        ind2=(rnd_mat>PH1).*(rnd_mat<=(PH1+PH2));
        ind3=(rnd_mat>(PH1+PH2)).*(rnd_mat<=(PH1+PH2+PH3));
        ind4=(rnd_mat>(PH1+PH2+PH3));

        Pbar.a=O1.*(ind1+ind2);
        HFP.a=O1.*(ind1+ind4);
        EHFP.a=PH1./(eps+PHsum);
   
        %%%%%%%%%%%%%%%%%%%%%
        VFPP.b=(W*(HFP.a.*Pbar.a)+repmat(c(:),1,MiniBatchLen)).';
        VFP.b=VFP.a;

        VFPP.b=exp(VFPP.b-repmat(max(VFPP.b,[],2),[1 size(VFPP.b,2)]));
        cumsumPV=double(gather(cumsum(VFPP.b,2)));
        %%%%%%%%%%%%%%%%

        num_of_words=gather(sum(MiniBatchData,2)); 
        tmp_indices=zeros(MiniBatchLen*max(num_of_words)-sum(num_of_words),1);
        cnt=1;
        max_num_of_words=max(num_of_words);
        for m0=1:MiniBatchLen
            tmp_indices(cnt:cnt+(max_num_of_words-num_of_words(m0))-1)=m0+MiniBatchLen*(num_of_words(m0):max_num_of_words-1);
            cnt=cnt+(max_num_of_words-num_of_words(m0));
        end
  
        num_of_words=double(gather(sum(MiniBatchData,2))); 
        num_of_words0=num_of_words;
        Yrnd=parallel.gpu.GPUArray.rand(MiniBatchLen,max(num_of_words),'single').*repmat((gpuArray(single(cumsumPV(:,end)))),[1 max(num_of_words)]);
        Yrnd(tmp_indices)=inf;%max(cumsumPV(:,end))+1.0;
        Yrnd=Yrnd(num_of_words>0,:);
        cumsumPV=cumsumPV(num_of_words>0,:);
        Yrnd=sort(Yrnd,2,'ascend');
        num_of_words=num_of_words(num_of_words>0);
                
        max_num_of_words=double(max(num_of_words));
        cumsumPV=double(gather(cumsumPV));
                
        Yrnd=double(gather(Yrnd));
        NVisible_k=size(MiniBatchData,2);
        mx=double(max_num_of_words);
        tmp=multinomial_sampler(cumsumPV(:), Yrnd(:), num_of_words(:), length(num_of_words), NVisible_k, mx);
        VFP.b(num_of_words0>0,:)=gpuArray(single(tmp));

        %%%%%%%%%%%%%%%%%%%%
        VFPP.b=VFPP.b./repmat(eps+sum(VFPP.b,2),[1 size(VFPP.b,2)]);
        VFPP.b=VFPP.b.*repmat(sum(VFP.b,2),[1,size(VFP.b,2)]); 
        %%%%%%%%%%%%%%%%%%%%%%%%%
        
        i0=1;
        while 1
            tmp=(W.'*VFP.b.'+b(:)*num_words_hist.');%./repmat(num_words_hist.',[NHidden,1]);
            PH1=log(P+eps)+tmp;
            PH2=log(P+eps);
            PH3=log(1.0-P+eps);
            PH4=log(1.0-P+eps);
            
            tmp_PH=parallel.gpu.GPUArray.zeros(NHidden*MiniBatchLen,4,'single');
            tmp_PH(:,1)=reshape(PH1,NHidden*MiniBatchLen,1);
            tmp_PH(:,2)=reshape(PH2,NHidden*MiniBatchLen,1);
            tmp_PH(:,3)=reshape(PH3,NHidden*MiniBatchLen,1);
            tmp_PH(:,4)=reshape(PH4,NHidden*MiniBatchLen,1);
            maxPH=reshape(max(tmp_PH,[],2),NHidden,MiniBatchLen);

            PH1=exp(PH1-maxPH);
            PH2=exp(PH2-maxPH);
            PH3=exp(PH3-maxPH);
            PH4=exp(PH4-maxPH);
            PHsum=PH1+PH2+PH3+PH4;
            
            rnd_mat=parallel.gpu.GPUArray.rand(NHidden,MiniBatchLen,'single').*PHsum;
            ind1=rnd_mat<=PH1;
            ind2=(rnd_mat>PH1).*(rnd_mat<=(PH1+PH2));
            ind3=(rnd_mat>(PH1+PH2)).*(rnd_mat<=(PH1+PH2+PH3));
            ind4=(rnd_mat>(PH1+PH2+PH3));

            Pbar.b=O1.*(ind1+ind2);
            HFP.b=O1.*(ind1+ind4);
            EHFP.b=PH1./(eps+PHsum);

            if i0<NContrastiveDivergence
                i0=i0+1;
                %%%%%%%%%%%%%%%%%%%%%
                VFPP.b=(W*(HFP.b.*Pbar.b)+repmat(c,1,MiniBatchLen)).';
                %%%%%%%%%%%%%%%%%%%%%%
                VFPP.b=exp(VFPP.b-repmat(max(VFPP.b,[],2),[1 size(VFPP.b,2)]));
                cumsumPV=double(gather(cumsum(VFPP.b,2)));

                num_of_words=double(gather(sum(MiniBatchData,2))); 
                num_of_words0=num_of_words;
                Yrnd=parallel.gpu.GPUArray.rand(MiniBatchLen,max(num_of_words),'single').*repmat((gpuArray(single(cumsumPV(:,end)))),[1 max(num_of_words)]);
                Yrnd(tmp_indices)=inf;%max(cumsumPV(:,end))+1.0;
                Yrnd=Yrnd(num_of_words>0,:);
                cumsumPV=cumsumPV(num_of_words>0,:);
                Yrnd=sort(Yrnd,2,'ascend');
                num_of_words=num_of_words(num_of_words>0);
                        
                max_num_of_words=double(max(num_of_words));
                cumsumPV=double(gather(cumsumPV));
                        
                Yrnd=double(gather(Yrnd));
                NVisible_k=size(MiniBatchData,2);
                mx=double(max_num_of_words);
                tmp=multinomial_sampler(cumsumPV(:), Yrnd(:), num_of_words(:), length(num_of_words), NVisible_k, mx);
                VFP.b(num_of_words0>0,:)=gpuArray(single(tmp));
                %%%%%%%%%%%%%%%%%%%%
                VFPP.b=VFPP.b./repmat(eps+sum(VFPP.b,2),[1 size(VFPP.b,2)]);
                VFPP.b=VFPP.b.*repmat(sum(VFP.b,2),[1,size(VFP.b,2)]); 
                %%%%%%%%%%%%%%%%%%%%%%%%%
            else
                break;
            end
        end             
    end
    Data=cell(num_of_hist_boxes,3);
    VIndices=gpuArray(single(VIndices0));
    num_of_classes=length(unique(VIndices0));
    for i=1:num_of_hist_boxes
        for j=1:3
            Data{i,j}=gpuArray(single(Data0{i,j}));% ones(size(Data0,1),1)]));
        end
    end
    NLayers=size(NHidden,1);
    c=cell(NLayers,num_of_hist_boxes,3);
    b=cell(NLayers,num_of_hist_boxes,3);
    W=cell(NLayers,num_of_hist_boxes,3);
    Beta=cell(NLayers,num_of_hist_boxes,3);
    NVisible=zeros(NLayers,num_of_hist_boxes,3);
    NTrainingSamples=size(Data{1,1},1);

    for i=1:NLayers
        if i==1
            for i3=1:num_of_hist_boxes
                for j=1:3
                    NVisible(i,i3,j)=size(Data{i3,j},2);
                    c{i,i3,j}=parallel.gpu.GPUArray.randn(NVisible(i,i3,j),1,'single')*0.001;
                    b{i,i3,j}=parallel.gpu.GPUArray.randn(NHidden(i,i3,j),1,'single')*0.001;
                    W{i,i3,j}=parallel.gpu.GPUArray.randn(NVisible(i,i3,j),NHidden(i,i3,j),'single')*0.001;
                    Beta{i,i3,j}=parallel.gpu.GPUArray.zeros(NHidden(i,i3,j),num_of_classes,'single');
                    for index=1:num_of_classes
%                       Beta{i}(:,j)=gpuArray(single(max([0.01*ones(NHidden(i),1),betarnd(cparm*gather(BaseBeta{i}),...
%                                                        cparm*(1.0-gather(BaseBeta{i})))],[],2)));
                        Beta{i,i3,j}(:,index)=gpuArray(single(max([0.01*ones(NHidden(i,i3,j),1),betarnd(aparm*ones(NHidden(i,i3,j),1)/NHidden(i,i3,j),...
                                                       bparm*(1.0-ones(NHidden(i,i3,j),1)/NHidden(i,i3,j)))],[],2)));
                    end                          
                end
            end
        else
            if i==2
                NVisible(i,1,1)=sum(sum(squeeze(NHidden(i-1,:,:))))+1;
            else
                NVisible(i,1,1)=NHidden(i-1,1,1)+1;
            end
            c{i,1,1}=parallel.gpu.GPUArray.randn(NVisible(i,1,1),1,'single')*0.001;
            b{i,1,1}=parallel.gpu.GPUArray.randn(NHidden(i,1,1),1,'single')*0.001;
            W{i,1,1}=parallel.gpu.GPUArray.randn(NVisible(i,1,1),NHidden(i,1,1),'single')*0.001;
            Beta{i,1,1}=parallel.gpu.GPUArray.zeros(NHidden(i,1,1),num_of_classes,'single');
            for index=1:num_of_classes
%             Beta{i}(:,j)=gpuArray(single(max([0.01*ones(NHidden(i),1),betarnd(cparm*gather(BaseBeta{i}),...
%                                                        cparm*(1.0-gather(BaseBeta{i})))],[],2)));
                Beta{i,1,1}(:,index)=gpuArray(single(max([0.01*ones(NHidden(i,1,1),1),betarnd(aparm*ones(NHidden(i,1,1),1)/NHidden(i,1,1),...
                                                       bparm*(1.0-ones(NHidden(i,1,1),1)/NHidden(i,1,1)))],[],2)));
            end                              
        end
        
    end
    % W: num_of_visible_variables x num_of_hidden_variables
    % V: num_of_sample_images x num_of_visible_variables    
    % H: num_of_hidden_variables x num_of_sample_images
    % P: num_of_hidden_variables x num_of_sample_images

    HFP=cell(NLayers,num_of_hist_boxes,3);
    VFP=cell(NLayers,num_of_hist_boxes,3);
    Pbar=cell(NLayers,num_of_hist_boxes,3);
    VFPP=cell(NLayers,num_of_hist_boxes,3);
    EHFP=cell(NLayers,num_of_hist_boxes,3);
    for k=1:NLayers
        for n=1:num_iterations(k)
            alpha=(n+tau0)^(-kappa);
            rndIndices = gpuArray(single(randperm(NTrainingSamples)));
            if k==1
                tmpBetaMat=cell(num_of_hist_boxes,3);
                tmpBetaMatC=cell(num_of_hist_boxes,3);
                for i3=1:num_of_hist_boxes
                    for j=1:3
                        tmpBetaMat{i3,j}=parallel.gpu.GPUArray.zeros(NHidden(k,i3,j),num_of_classes);
                        tmpBetaMatC{i3,j}=parallel.gpu.GPUArray.zeros(NHidden(k,i3,j),num_of_classes);
                    end
                end
            else
                tmpBetaMat=cell(1,1);
                tmpBetaMatC=cell(1,1);
                tmpBetaMat{1}=parallel.gpu.GPUArray.zeros(NHidden(k,1,1),num_of_classes);
                tmpBetaMatC{1}=parallel.gpu.GPUArray.zeros(NHidden(k,1,1),num_of_classes);
            end        
            W0=W;
            b0=b;
            for i=1:MiniBatchLen:NTrainingSamples
                if i+MiniBatchLen-1>NTrainingSamples
                    continue;
                end
                if k==1
                    for i3=1:num_of_hist_boxes
                        for j=1:3
                            MiniBatchData=Data{i3,j}(rndIndices(i:i+MiniBatchLen-1),:);
                            P=Beta{k,i3,j}(:,VIndices(rndIndices(i:i+MiniBatchLen-1)));
%                           'Contrastive Divergence'
%                           tic
                            [HFP5,VFP5,Pbar5,VFPP5,EHFP5]=ContrastiveDivergence(MiniBatchData,W{k,i3,j},P,b{k,i3,j},c{k,i3,j},NContrastiveDivergence,NHidden(k,i3,j),MiniBatchLen,NVisible(k,i3,j));
                            [Pbar10]=SampleP(MiniBatchData,W0{k,i3,j},P,b0{k,i3,j},NHidden(k,i3,j),MiniBatchLen);
                            tmpW=MiniBatchData.'*EHFP5.a.'/MiniBatchLen;
                            tmpW2=VFP5.b.'*EHFP5.b.'/MiniBatchLen;
                            W{k,i3,j}=W{k,i3,j}+alpha*(tmpW-tmpW2)-alpha*l2reg(k)*W{k,i3,j};
                            b{k,i3,j}=b{k,i3,j}+alpha*(mean(EHFP5.a,2)-mean(EHFP5.b,2));%-1e-4;
                            c{k,i3,j}=c{k,i3,j}+alpha*(mean(MiniBatchData,1).'-mean(VFPP5.b,1).');
                            for index=1:num_of_classes
                                tmpI=find(VIndices(rndIndices(i:i+MiniBatchLen-1))==index);
                                if isempty(tmpI)
                                    continue;
                                end
                                tmpBetaMat{i3,j}(:,index)=tmpBetaMat{i3,j}(:,index)+squeeze(sum(Pbar10.a(:,tmpI),2));
                                tmpBetaMatC{i3,j}(:,index)=tmpBetaMatC{i3,j}(:,index)+squeeze(sum(1-Pbar10.a(:,tmpI),2));
%                                 %tmpBeta=betarnd(cparm*gather(BaseBeta{k})+squeeze(gather(sum(Pbar{k}.a(:,tmpI),2))),...
%                                 %    cparm*(1.0-gather(BaseBeta{k}))+squeeze(gather(sum(1.0-Pbar{k}.a(:,tmpI),2))));
%                                 tmpBeta=betarnd(aparm*ones(NHidden(k,i3,j),1)/double(NHidden(k,i3,j))+squeeze(gather(sum(Pbar5.a(:,tmpI),2)))*min(sum(gather(double(VIndices))==index),MiniBatchLen)/length(tmpI),...
%                                     bparm*(1.0-ones(NHidden(k,i3,j),1)/double(NHidden(k,i3,j)))+squeeze(gather(sum(1.0-Pbar5.a(:,tmpI),2)))*min(sum(gather(double(VIndices))==index),MiniBatchLen)/length(tmpI));
% %                               BetaMat(:,j)=tmpBeta;
%                                 tmpBeta=(1-alpha)*gather(Beta{k,i3,j}(:,index))+alpha*tmpBeta;
%                                 Beta{k,i3,j}(:,index)=gpuArray(single(max([0.000001*ones(NHidden(k,i3,j),1) min([(1.0-0.000001)*ones(NHidden(k,i3,j),1) tmpBeta],[],2)],[],2)));
                            end
                        end
                    end
                else
                    tmpEHFP=parallel.gpu.GPUArray.ones(MiniBatchLen,NVisible(2,1,1),'single');
                    cnt0=1;
                    for i3=1:num_of_hist_boxes
                        for j=1:3
                            MiniBatchData=Data{i3,j}(rndIndices(i:i+MiniBatchLen-1),:);
                            tmpEHFP(:,cnt0:cnt0+NHidden(1,i3,j)-1)=propagate_data(MiniBatchData,W0{1,i3,j},b0{1,i3,j}).';%EHFP{k-1,i3,j}.a.';  % The bug is here!
                            cnt0=cnt0+NHidden(1,i3,j);
                        end
                    end
                    if k>2
                        for kj=3:k
                            tmpEHFP2=parallel.gpu.GPUArray.ones(MiniBatchLen,NVisible(kj,1,1),'single');
                            tmpEHFP2(:,1:end-1)=propagate_data2(tmpEHFP,W0,b0,kj).';
                            tmpEHFP=tmpEHFP2;
                        end
                    end
                    P=Beta{k,1,1}(:,VIndices(rndIndices(i:i+MiniBatchLen-1)));
                    [HFP{k,1,1},VFP{k,1,1},Pbar{k,1,1},VFPP{k,1,1},EHFP{k,1,1}]=ContrastiveDivergence2(tmpEHFP,W{k,1,1},P,b{k,1,1},c{k,1,1},NContrastiveDivergence,NHidden(k,1,1),MiniBatchLen,NVisible(k,1,1));
                    [Pbar10]=SampleP2(tmpEHFP,W0{k,1,1},P,b0{k,1,1},NHidden(k,1,1),MiniBatchLen);
                    tmpW=(tmpEHFP.')*EHFP{k,1,1}.a.'/MiniBatchLen;
                    tmpW2=VFP{k,1,1}.b.'*EHFP{k,1,1}.b.'/MiniBatchLen;
                    W{k,1,1}=W{k,1,1}+alpha*(tmpW-tmpW2)-alpha*l2reg(k)*W{k,1,1};
                    b{k,1,1}=b{k,1,1}+alpha*(mean(EHFP{k,1,1}.a,2)-mean(EHFP{k,1,1}.b,2));%-1e-4;
                    c{k,1,1}=c{k,1,1}+alpha*(mean(tmpEHFP.',2)-mean(VFPP{k,1,1}.b,1).');
                    for index=1:num_of_classes
                        tmpI=find(VIndices(rndIndices(i:i+MiniBatchLen-1))==index);
                        if isempty(tmpI)
                            continue;
                        end
                        tmpBetaMat{1}(:,index)=tmpBetaMat{1}(:,index)+squeeze(sum(Pbar10.a(:,tmpI),2));
                        tmpBetaMatC{1}(:,index)=tmpBetaMatC{1}(:,index)+squeeze(sum(1-Pbar10.a(:,tmpI),2));
                        %tmpBeta=betarnd(cparm*gather(BaseBeta{k})+squeeze(gather(sum(Pbar{k}.a(:,tmpI),2))),...
                        %    cparm*(1.0-gather(BaseBeta{k}))+squeeze(gather(sum(1.0-Pbar{k}.a(:,tmpI),2))));
%                         tmpBeta=betarnd(aparm*ones(NHidden(k,1,1),1)/double(NHidden(k,1,1))+squeeze(gather(sum(Pbar{k,1,1}.a(:,tmpI),2)))*min(sum(gather(double(VIndices))==index),MiniBatchLen)/length(tmpI),...
%                             bparm*(1.0-ones(NHidden(k,1,1),1)/double(NHidden(k,1,1)))+squeeze(gather(sum(1.0-Pbar{k,1,1}.a(:,tmpI),2)))*min(sum(gather(double(VIndices))==index),MiniBatchLen)/length(tmpI));
% %                       BetaMat(:,j)=tmpBeta;
%                         tmpBeta=(1-alpha)*gather(Beta{k,1,1}(:,index))+alpha*tmpBeta;
%                         Beta{k,1,1}(:,index)=gpuArray(single(max([0.000001*ones(NHidden(k,1,1),1) min([(1.0-0.000001)*ones(NHidden(k,1,1),1) tmpBeta],[],2)],[],2)));
                    end
                end
            end
            
            if k==1
                tmpBetaMat0=cell(num_of_hist_boxes,3);
                tmpBetaMatC0=cell(num_of_hist_boxes,3);
                for i3=1:num_of_hist_boxes
                    for j=1:3
                        tmpBetaMat0{i3,j}=gather(tmpBetaMat{i3,j});
                        tmpBetaMatC0{i3,j}=gather(tmpBetaMatC{i3,j});
                    end
                end
            else
                tmpBetaMat0=cell(1,1);
                tmpBetaMatC0=cell(1,1);
                tmpBetaMat0{1}=gather(tmpBetaMat{1});
                tmpBetaMatC0{1}=gather(tmpBetaMatC{1});
            end   
                            
            for index=1:num_of_classes
                if k==1
                    for i3=1:num_of_hist_boxes
                        for j=1:3
                            Beta{k,i3,j}(:,index)=...
                                gpuArray(single(betarnd(aparm*ones(NHidden(k,i3,j),1)/double(NHidden(k,i3,j))+tmpBetaMat0{i3,j}(:,index),...
                                bparm*(1.0-ones(NHidden(k,i3,j),1)/double(NHidden(k,i3,j)))+tmpBetaMatC0{i3,j}(:,index))));
%                             Beta{k,i3,j}(:,index)=gpuArray(single(max([0.00000001*ones(NHidden(k,i3,j),1) min([(1.0-0.00000001)*ones(NHidden(k,i3,j),1) Beta{k,i3,j}(:,index)],[],2)],[],2)));
                        end
                    end
                else
                    Beta{k,1,1}(:,index)=...
                                gpuArray(single(betarnd(aparm*ones(NHidden(k,1,1),1)/double(NHidden(k,1,1))+tmpBetaMat0{1}(:,index),...
                                bparm*(1.0-ones(NHidden(k,1,1),1)/double(NHidden(k,1,1)))+tmpBetaMatC0{1}(:,index))));
%                     Beta{k,1,1}(:,index)=gpuArray(single(max([0.00000001*ones(NHidden(k,1,1),1) min([(1.0-0.00000001)*ones(NHidden(k,1,1),1) Beta{k,1,1}(:,index)],[],2)],[],2)));
                end
            end
            [n sum(Beta{k,1,1}>0.01)]
        end
    end
    Beta2=cell(NLayers,num_of_hist_boxes,3);
    W2=cell(NLayers,num_of_hist_boxes,3);
    b2=cell(NLayers,num_of_hist_boxes,3);
    c2=cell(NLayers,num_of_hist_boxes,3);
    for k=1:NLayers
        if k==1;
            for i3=1:num_of_hist_boxes
                for j=1:3
                    Beta2{k,i3,j}=gather(Beta{k,i3,j});
                    W2{k,i3,j}=gather(W{k,i3,j});
                    b2{k,i3,j}=gather(b{k,i3,j});
                    c2{k,i3,j}=gather(c{k,i3,j});
                end
            end
        else
            Beta2{k,1,1}=gather(Beta{k,1,1});
            W2{k,1,1}=gather(W{k,1,1});
            b2{k,1,1}=gather(b{k,1,1});
            c2{k,1,1}=gather(c{k,1,1});
        end
    end
end
